import 'package:mercury/mercury.dart';

import 'package:w_transport/vm.dart' show vmTransportPlatform;

Session bot;
LoggerContext logger = new LoggerContext.root('Basic Commands Example');

void main() {
  bot = new Session(vmTransportPlatform);
  bot.setToken('myToken', TokenType.Bot);

  bot.dispatcher.ready.listen((empty) {
    logger.log(LogLevel.Info, 'Client is ready.');
  });

  bot.dispatcher.messageCreate.listen((Message message) async {
    var content = message.content;
    var authorUsername = message.author.username;
    var channel = message.channel;
    var guild = message.channel.guild;

    if (content == '!ping') {
      await channel.createMessage('**${authorUsername}**, pong!');
    }
    if (content == '!guild' || content == '!server') {
      await channel.createMessage(
          '**${authorUsername}**, we are currently in the **${guild.name}** server.');
    }
  });

  bot.connect();
}
