part of mercury;

/// A set of options for modifying a [ChannelBase].
class ChannelUpdateProperties {
  /// (All) The name of this channel.
  String name;

  /// (All) The position of this channel.
  int sortingPosition;

  /// (Text) The topic of this channel.
  String topic;

  /// (Text) Whether this channel is NSFW.
  bool isNsfw;

  /// (Voice) The user limit of this channel.
  int userLimit;

  /// (Voice) The bitrate (in bits) of this voice channel.
  ///
  /// Between 8,000 and 96,000 (128,000 for VIP servers)
  int bitrate;

  // TODO: Permission overwrites

  /// (Text, Voice) The ID of the parent category of this channel.
  String parentCategoryId;

  Map<String, dynamic> build(Map<String, dynamic> json, Session client) {
    if (name != null) json['name'] = name;
    if (sortingPosition != null) json['position'] = sortingPosition;
    if (topic != null) json['topic'] = topic;
    if (isNsfw != null) json['nsfw'] = isNsfw;
    if (bitrate != null) json['bitrate'] = bitrate;
    if (userLimit != null) json['user_limit'] = userLimit;
    if (parentCategoryId != null) json['parent_id'] = parentCategoryId;
    return json;
  }
}
