part of mercury;

/// Represents a user on Discord.
class User extends EntityBase {
  /// The user's username, not unique across Discord
  String username = '';

  /// The user's discriminator, their 4-digit Discord tag
  String discriminator = '';

  /// The integer value of the user's discriminator
  int discriminatorValue = 0;

  /// Whether the user belongs to an OAuth2 application
  bool isBot = false;

  /// Whether the user has Two-Factor Authentication (2FA) enabled
  bool twoFactorEnabled = false;

  User(Session client) : super(client);

  @override
  Future _update(Map<String, dynamic> json) async {
    await super._update(json);
    id = json['id'] ?? id;
    username = json['username'] ?? username;
    discriminator = json['discriminator'] ?? discriminator;
    discriminatorValue = int.parse(discriminator);
    isBot = json['bot'] ?? isBot;
    twoFactorEnabled = json['mfa_enabled'] ?? twoFactorEnabled;
  }
}
