part of mercury;

/// Automatically sends heartbeats on a predetermined interval.
class _Heartbeat {
  /// The client that owns this heartbeater.
  Session _client;

  /// The predetermined interval to heartbeat (in milliseconds)
  int hbInterval;

  /// The Dart timer that handles starting the hearbeat.
  Timer _hbTimer;

  /// Default constructor
  _Heartbeat(this._client, this.hbInterval) {}

  /// Begins heartbeating on the interval specified.
  void begin() {
    _hbTimer = new Timer.periodic(
        new Duration(milliseconds: this.hbInterval), sendHeartbeat);
  }

  /// Executed when the timer signals that the heartbeat interval has passed.
  Future sendHeartbeat(Timer timer) async {
    var payload = new WSPayloadPacket();
    payload.opCode = ApiEndpoints.opCodes[1];
    payload.innerPayload = _client._ws.currentSeq;
    _client._ws.sendMessage(payload);
  }

  /// Stops heartbeating.
  void stop() {
    _hbTimer.cancel();
    _hbTimer = null;
  }
}
